#pragma once

#include <cmath>
#include "resummation.hh"


class Lagrange {
public:
  Lagrange(resumm::Resummation *r);
  ~Lagrange();
  //
  int ApproxLuminosity   (double *coeff, unsigned int N=10, double beta=3., int gamma=5, double z_min=1.e-5);
  //
  void EnableQualityCheck(bool enable=true);


private:
  double beta_lum;
  int gamma_lum;
  bool quality_check;
  resumm::Resummation *res;
  double fLum_log(double z, void *p);
  //double Lum_func(Lum_type, double, void*);
  //
  friend double integrand_QC(double z, void *p);
  //
  int approx(unsigned int, double *, double *, void *p=NULL);


};




